﻿//-----------------------------------------------
//API for TUSB-INS16I Driver
//Visual C# Module
//
//Jan. 30 2014
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//'-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBINSI
{
    [DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins16i_Device_Open(short id);
    [DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbins16i_Device_Close(short id);
    [DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins16i_Read(short id,out int dat);
    [DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins16i_EdgeSet(short id, int dat, byte time);
    [DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbins16i_EdgeRead(short id, out int dat);

    public static string GetOpenErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            default:
                return "不明なエラーです";
        }
    }

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "このデバイスはオープンされていません";
            case 2:
                return "失敗しました";
            default:
                return "不明なエラーです";
        }
    }
}

