//-----------------------------------------------
//API for TUSB-INS16I Driver
//Visual Cpp/CLI Module
//
//Jan. 30 2014
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//'-----------------------------------------------

#ifndef TUSBINSI_h
#define TUSBINSI_h

using namespace System;
using namespace System::Runtime::InteropServices;

[DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbins16i_Device_Open(short id);
[DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention::Cdecl)]
extern void Tusbins16i_Device_Close(short id);
[DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbins16i_Read(short id, int *dat);
[DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbins16i_EdgeSet(short id, int dat, unsigned char time);
[DllImport("TUSBINSI.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbins16i_EdgeRead(short id, int *dat);

static String^ Tusbins16i_GetOpenErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "IDԍsł";
        case 3:
            return "łɃfoCX̓I[vĂ܂";
        case 4:
            return "ڑĂ䐔܂";
        case 5:
            return "I[vł܂ł";
        case 6:
            return "foCX݂܂";
        default:
            return "sȃG[ł";
    }
}

static String^ Tusbins16i_GetErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "̃foCX̓I[vĂ܂";
        case 2:
            return "s܂";
        default:
            return "sȃG[ł";
    }
}

#endif
