﻿Public Class Form1
    Private DevId As Short
    Private StatDisp() As System.Windows.Forms.PictureBox
    Private DirCntl() As System.Windows.Forms.PictureBox
    Private EdgeDisp() As System.Windows.Forms.PictureBox

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

        StatDisp = New System.Windows.Forms.PictureBox() _
            {DispB0, DispB1, DispB2, DispB3, DispB4, DispB5, DispB6, DispB7, _
             DispB8, DispB9, DispB10, DispB11, DispB12, DispB13, DispB14, DispB15}
        DirCntl = New System.Windows.Forms.PictureBox() _
            {Dir0, Dir1, Dir2, Dir3, Dir4, Dir5, Dir6, Dir7, _
             Dir8, Dir9, Dir10, Dir11, Dir12, Dir13, Dir14, Dir15}
        EdgeDisp = New System.Windows.Forms.PictureBox() _
            {Edge0, Edge1, Edge2, Edge3, Edge4, Edge5, Edge6, Edge7, _
             Edge8, Edge9, Edge10, Edge11, Edge12, Edge13, Edge14, Edge15}

    End Sub

    Private Sub ControlEnable(ByVal en As Boolean)
        DevOpenBtn.Enabled = Not en
        IDNUM.Enabled = Not en
        DevCloseBtn.Enabled = en
        Timer1.Enabled = en
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim Bit As Integer

        DevId = 0
        ControlEnable(False)

        Timer1.Interval = 300
        IDNUM.SelectedIndex = 0
        For Bit = 0 To 15
            StatDisp(Bit).Image = ImageList1.Images("Off")
            DirCntl(Bit).Image = ImageList1.Images("UpEdge")
            DirCntl(Bit).Tag = False
            EdgeDisp(Bit).Image = ImageList1.Images("Off")
        Next
    End Sub

    Private Sub DevOpenBtn_Click(sender As System.Object, e As System.EventArgs) Handles DevOpenBtn.Click
        Dim retErr As Short

        DevId = IDNUM.SelectedIndex
        retErr = Tusbins16i_Device_Open(DevId)
        If (retErr = 0) Then
            ControlEnable(True)
            EdgeSet()
        Else
            Tusbins16i_OpenErrorDisp(retErr) '***オープンに失敗した場合
        End If

    End Sub

    Private Sub DevClose()
        Tusbins16i_Device_Close(DevId)
        ControlEnable(False)
    End Sub

    Private Sub DevCloseBtn_Click(sender As System.Object, e As System.EventArgs) Handles DevCloseBtn.Click
        DevClose()
    End Sub

    Private Sub EdgeSet()
        Dim Bit As Integer
        Dim dat As Integer
        Dim retErr As Short

        dat = 0
        For Bit = 0 To 15
            dat += IIf(DirCntl(Bit).Tag, 1 << Bit, 0)
        Next

        retErr = Tusbins16i_EdgeSet(DevId, dat, IntervalTime.Value)
        If retErr <> 0 Then
            Tusbins16i_ErrorDisp(retErr)
            DevClose()
        End If
    End Sub

    Private Sub Dir_MouseClick(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles Dir0.MouseClick, Dir9.MouseClick, Dir8.MouseClick, Dir7.MouseClick, Dir6.MouseClick, Dir5.MouseClick, Dir4.MouseClick, Dir3.MouseClick, Dir2.MouseClick, Dir15.MouseClick, Dir14.MouseClick, Dir13.MouseClick, Dir12.MouseClick, Dir11.MouseClick, Dir10.MouseClick, Dir1.MouseClick
        Dim image As System.Windows.Forms.PictureBox = CType(sender, System.Windows.Forms.PictureBox)

        If (image.Tag) Then
            image.Tag = False
            image.Image = ImageList1.Images("UpEdge")
        Else
            image.Tag = True
            image.Image = ImageList1.Images("DownEdge")
        End If
        EdgeSet()
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim dat As Integer
        Dim Bit As Integer
        Dim retErr As Short

        retErr = Tusbins16i_Read(DevId, dat)
        If retErr <> 0 Then '***DLL関数の実行
            Tusbins16i_ErrorDisp(retErr) '***書きこみ失敗
            DevClose()
            Return
        Else
            For Bit = 0 To 15
                StatDisp(Bit).Image = IIf(dat And (1 << Bit), _
                                          ImageList1.Images("On"), _
                                          ImageList1.Images("Off"))
            Next
        End If

        retErr = Tusbins16i_EdgeRead(DevId, dat)
        If retErr <> 0 Then '***DLL関数の実行
            Tusbins16i_ErrorDisp(retErr) '***書きこみ失敗
            DevClose()
            Return
        Else
            For Bit = 0 To 15
                EdgeDisp(Bit).Image = IIf(dat And (1 << Bit), _
                                          ImageList1.Images("On"), _
                                          ImageList1.Images("Off"))
            Next
        End If
    End Sub

    Private Sub IntervalTime_ValueChanged(sender As System.Object, e As System.EventArgs) Handles IntervalTime.ValueChanged
        EdgeSet()
    End Sub
End Class
